summaryrefslogtreecommitdiff
path: root/eclass
diff options
context:
space:
mode:
authorTomas Chvatal <scarabeus@gentoo.org>2011-03-09 13:31:51 +0000
committerTomas Chvatal <scarabeus@gentoo.org>2011-03-09 13:31:51 +0000
commit21d6c3baf7783a98116be51359e0e61161782f57 (patch)
treee1a2627bc657208556a5d419afb04240c23c5899 /eclass
parentStable on amd64 wrt bug #353450 (diff)
downloadhistorical-21d6c3baf7783a98116be51359e0e61161782f57.tar.gz
historical-21d6c3baf7783a98116be51359e0e61161782f57.tar.bz2
historical-21d6c3baf7783a98116be51359e0e61161782f57.zip
Sync virtualx.eclass from x11 overlay as per review ~week ago.
Diffstat (limited to 'eclass')
-rw-r--r--eclass/virtualx.eclass173
1 files changed, 101 insertions, 72 deletions
diff --git a/eclass/virtualx.eclass b/eclass/virtualx.eclass
index 52d1284c2eca..0eb2f407e305 100644
--- a/eclass/virtualx.eclass
+++ b/eclass/virtualx.eclass
@@ -1,118 +1,137 @@
# Copyright 1999-2010 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
-# $Header: /var/cvsroot/gentoo-x86/eclass/virtualx.eclass,v 1.35 2010/05/15 05:40:46 dirtyepic Exp $
+# $Header: /var/cvsroot/gentoo-x86/eclass/virtualx.eclass,v 1.36 2011/03/09 13:31:51 scarabeus Exp $
# Original author: Martin Schlemmer <azarah@gentoo.org>
# @ECLASS: virtualx.eclass
# @MAINTAINER:
-# x11@gentoo.org
+# x11@gentoo.org
# @BLURB: This eclass can be used for packages that needs a working X environment to build.
# @ECLASS-VARIABLE: VIRTUALX_REQUIRED
# @DESCRIPTION:
-# Is a dependency on xorg-server and xhost needed?
-# Valid values are "always", "optional", and "manual".
-# "tests" is a synonym for "optional".
-: ${VIRTUALX_REQUIRED:=optional}
-
-# @ECLASS-VARIABLE: VIRTUALX_USE
-# @DESCRIPTION:
-# If VIRTUALX_REQUIRED=optional, what USE flag should control
-# the dependency?
-: ${VIRTUALX_USE:=test}
+# Variable specifying the dependency on xorg-server and xhost.
+# Possible special values are "always" and "manual", which specify
+# the dependency to be set unconditionaly or not at all.
+# Any other value is taken as useflag desired to be in control of
+# the dependency (eg. VIRTUALX_REQUIRED="kde" will add the dependency
+# into "kde? ( )" and add kde into IUSE.
+: ${VIRTUALX_REQUIRED:=test}
# @ECLASS-VARIABLE: VIRTUALX_DEPEND
# @DESCRIPTION:
-# Dep string available for use outside of eclass, in case a more
-# complicated dep is needed.
-VIRTUALX_DEPEND="!prefix? ( x11-base/xorg-server )
- x11-apps/xhost"
+# Dep string available for use outside of eclass, in case a more
+# complicated dep is needed.
+# You can specify the variable BEFORE inherit to add more dependencies.
+VIRTUALX_DEPEND="${VIRTUALX_DEPEND}
+ !prefix? ( x11-base/xorg-server[-minimal] )
+ x11-apps/xhost
+"
+
+# @ECLASS-VARIABLE: VIRTUALX_COMMAND
+# @DESCRIPTION:
+# Command (or eclass function call) to be run in the X11 environment
+# (within virtualmake function).
+: ${VIRTUALX_COMMAND:="emake"}
+
+has "${EAPI:-0}" 0 1 && die "virtualx eclass require EAPI=2 or newer."
case ${VIRTUALX_REQUIRED} in
+ manual)
+ ;;
always)
DEPEND="${VIRTUALX_DEPEND}"
RDEPEND=""
;;
optional|tests)
+ # deprecated section YAY.
+ ewarn "QA: VIRTUALX_REQUIRED=optional and VIRTUALX_REQUIRED=tests are deprecated."
+ ewarn "QA: You can drop the variable definition completely from ebuild,"
+ ewarn "QA: because it is default behaviour."
+
+ if [[ -n ${VIRTUALX_USE} ]]; then
+ # so they like to specify the useflag
+ ewarn "QA: VIRTUALX_USE variable is deprecated."
+ ewarn "QA: Please read eclass manpage to find out how to use VIRTUALX_REQUIRED"
+ ewarn "QA: to achieve the same behaviour."
+ fi
+
+ [[ -z ${VIRTUALX_USE} ]] && VIRTUALX_USE="test"
DEPEND="${VIRTUALX_USE}? ( ${VIRTUALX_DEPEND} )"
RDEPEND=""
IUSE="${VIRTUALX_USE}"
;;
- manual)
- ;;
*)
- eerror "Invalid value (${VIRTUALX_REQUIRED}) for VIRTUALX_REQUIRED"
- eerror "Valid values are:"
- eerror " always"
- eerror " optional (default if unset)"
- eerror " manual"
- die "Invalid value (${VIRTUALX_REQUIRED}) for VIRTUALX_REQUIRED"
+ DEPEND="${VIRTUALX_REQUIRED}? ( ${VIRTUALX_DEPEND} )"
+ RDEPEND=""
+ IUSE="${VIRTUALX_REQUIRED}"
;;
esac
+# @FUNCTION: virtualmake
+# @DESCRIPTION:
+# Function which attach to running X session or start new Xvfb session
+# where the VIRTUALX_COMMAND variable content gets executed.
virtualmake() {
+ debug-print-function ${FUNCNAME} "$@"
+
+ local i=0
local retval=0
local OLD_SANDBOX_ON="${SANDBOX_ON}"
local XVFB=$(type -p Xvfb)
local XHOST=$(type -p xhost)
+ local xvfbargs="-screen 0 800x600x24"
+
+ # backcompat for maketype
+ if [[ -n ${maketype} ]]; then
+ ewarn "QA: ebuild is exporting \$maketype=${maketype}"
+ ewarn "QA: Ebuild should be migrated to use VIRTUALX_COMMAND=${maketype} instead."
+ ewarn "QA: Setting VIRTUALX_COMMAND to \$maketype conveniently for now."
+ VIRTUALX_COMMAND=${maketype}
+ fi
# If $DISPLAY is not set, or xhost cannot connect to an X
# display, then do the Xvfb hack.
if [[ -n ${XVFB} && -n ${XHOST} ]] && \
- ( [[ -z ${DISPLAY} ]] || ! (${XHOST} &>/dev/null) ) ; then
+ ( [[ -z ${DISPLAY} ]] || ! (${XHOST} &>/dev/null) ) ; then
+ debug-print "${FUNCNAME}: running Xvfb hack"
export XAUTHORITY=
# The following is derived from Mandrake's hack to allow
# compiling without the X display
einfo "Scanning for an open DISPLAY to start Xvfb ..."
-
- # We really do not want SANDBOX enabled here
- export SANDBOX_ON="0"
-
- local i=0
- XDISPLAY=$(i=0; while [[ -f /tmp/.X${i}-lock ]] ; do ((i++));done; echo ${i})
-
# If we are in a chrooted environment, and there is already a
# X server started outside of the chroot, Xvfb will fail to start
# on the same display (most cases this is :0 ), so make sure
# Xvfb is started, else bump the display number
#
# Azarah - 5 May 2002
- #
- # Changed the mode from 800x600x32 to 800x600x24 because the mfb
- # support has been dropped in Xvfb in the xorg-x11 pre-releases.
- # For now only depths up to 24-bit are supported.
- #
- # Sven Wegener <swegener@gentoo.org> - 22 Aug 2004
- #
- # Use "-fp built-ins" because it's only part of the default font path
- # for Xorg but not the other DDXs (Xvfb, Kdrive, etc). Temporarily fixes
- # bug 278487 until xorg-server is properly patched
- #
- # Rémi Cardona <remi@gentoo.org> (10 Aug 2009)
- ${XVFB} :${XDISPLAY} -fp built-ins -screen 0 800x600x24 &>/dev/null &
+ XDISPLAY=$(i=0; while [[ -f /tmp/.X${i}-lock ]] ; do ((i++));done; echo ${i})
+ debug-print "${FUNCNAME}: XDISPLAY=${XDISPLAY}"
+
+ # We really do not want SANDBOX enabled here
+ export SANDBOX_ON="0"
+
+ debug-print "${FUNCNAME}: ${XVFB} :${XDISPLAY} ${xvfbargs}"
+ ${XVFB} :${XDISPLAY} ${xvfbargs} &>/dev/null &
sleep 2
local start=${XDISPLAY}
- while [[ ! -f /tmp/.X${XDISPLAY}-lock ]] ; do
+ while [[ ! -f /tmp/.X${XDISPLAY}-lock ]]; do
# Stop trying after 15 tries
if ((XDISPLAY - start > 15)) ; then
-
- eerror ""
- eerror "Unable to start Xvfb."
- eerror ""
- eerror "'${XVFB} :${XDISPLAY} -fp built-ins -screen 0 800x600x24' returns:"
- eerror ""
- ${XVFB} :${XDISPLAY} -fp built-ins -screen 0 800x600x24
- eerror ""
+ eerror "'${XVFB} :${XDISPLAY} ${xvfbargs}' returns:"
+ echo
+ ${XVFB} :${XDISPLAY} ${xvfbargs}
+ echo
eerror "If possible, correct the above error and try your emerge again."
- eerror ""
- die
+ die "Unable to start Xvfb"
fi
((XDISPLAY++))
- ${XVFB} :${XDISPLAY} -fp built-ins -screen 0 800x600x24 &>/dev/null &
+ debug-print "${FUNCNAME}: ${XVFB} :${XDISPLAY} ${xvfbargs}"
+ ${XVFB} :${XDISPLAY} ${xvfbargs} &>/dev/null &
sleep 2
done
@@ -122,42 +141,52 @@ virtualmake() {
einfo "Starting Xvfb on \$DISPLAY=${XDISPLAY} ..."
export DISPLAY=:${XDISPLAY}
- #Do not break on error, but setup $retval, as we need
- #to kill Xvfb
- ${maketype} "$@"
+ # Do not break on error, but setup $retval, as we need
+ # to kill Xvfb
+ debug-print "${FUNCNAME}: ${VIRTUALX_COMMAND} \"$@\""
+ ${VIRTUALX_COMMAND} "$@"
retval=$?
- #Now kill Xvfb
+ # Now kill Xvfb
kill $(cat /tmp/.X${XDISPLAY}-lock)
else
- #Normal make if we can connect to an X display
- ${maketype} "$@"
+ debug-print "${FUNCNAME}: attaching to running X display"
+ # Normal make if we can connect to an X display
+ debug-print "${FUNCNAME}: ${VIRTUALX_COMMAND} \"$@\""
+ ${VIRTUALX_COMMAND} "$@"
retval=$?
fi
- return ${retval}
+ # die if our command failed
+ [[ $? -ne 0 ]] && die "${FUNCNAME}: the ${VIRTALX_COMMAND} failed."
}
# @FUNCTION: Xmake
# @DESCRIPTION:
-# Same as "make", but set up the Xvfb hack if needed.
+# Same as "make", but set up the Xvfb hack if needed.
+# Deprecated call.
Xmake() {
- export maketype="make"
- virtualmake "$@"
+ debug-print-function ${FUNCNAME} "$@"
+
+ ewarn "QA: you should not execute make directly"
+ ewarn "QA: rather execute Xemake -j1 if you have issues with parallel make"
+ VIRTUALX_COMMAND="emake -j1" virtualmake "$@"
}
# @FUNCTION: Xemake
# @DESCRIPTION:
-# Same as "emake", but set up the Xvfb hack if needed.
+# Same as "emake", but set up the Xvfb hack if needed.
Xemake() {
- export maketype="emake"
- virtualmake "$@"
+ debug-print-function ${FUNCNAME} "$@"
+
+ VIRTUALX_COMMAND="emake" virtualmake "$@"
}
# @FUNCTION: Xeconf
# @DESCRIPTION:
# Same as "econf", but set up the Xvfb hack if needed.
Xeconf() {
- export maketype="econf"
- virtualmake "$@"
+ debug-print-function ${FUNCNAME} "$@"
+
+ VIRTUALX_COMMAND="econf" virtualmake "$@"
}